/*
  Blank Simple Project.c
  http://learn.parallax.com/propeller-c-tutorials 
*/
#include "simpletools.h"                      // Include simple tools
#include "fdserial.h"




struct nmea{

volatile char gpsname[6];
volatile int gpstime;
volatile char fix[1];
volatile float lat;
volatile char latchar[1];
volatile float longitude;
volatile char longchar[1];
volatile int sats;
volatile float alt;
volatile float dilution;
volatile float geoid;
volatile char altchar[1];
volatile float speed;
volatile float track;
volatile int date;
volatile int magvar;
}gps;

struct buffer{
volatile char NMEA[80]; //gps string 
volatile char gpsraw;
volatile char tempf[20];
volatile float floatemp;
}buff;

struct tempvars{
  
volatile double  fractparta; 
volatile double  fractpart;
}tvar;

volatile int latdeg;
volatile float latmintemp;
volatile double latmin;
volatile double latsec;
volatile int longdeg;
float longmintemp;
double longmin;
double longsec;

//forward declarations of functions used


struct nmea_time{
int hrs;
int min;
int sec;
}zulu;  

struct calendar{
int day;
int month;
int year;
}kenda;

int int_latmin;
int int_longmin;
void getdata2(); //receive data from gps
void parce_rmc();
void print_data(); 
void parce_time();
void print_full();
void init();

int index;

//HALF DUPLEX SERIAL USED IF USING ANOTHER DEVICE USE fdserial
serial *GPS;  //MASK FOR THE SERIAL INPUT
int rx_pin = 26;
int tx_pin = 20;  
int mode_ = 0;
int Baud_rate = 9600;


int main()                                    // Main function
{
    init();
    while(1)
    {
        // getdata();
        getdata2();
       // print_data();
        // print_data();
    } 
}  


void init()
{
#ifndef DEBUG
    GPS = serial_open(rx_pin,tx_pin,mode_ ,Baud_rate);
#endif
}


void getdata2()
{
    //read in characters from the GPS
    int idx = 0;
    do
    {
        buff.gpsraw = serial_rxChar(GPS);
        buff.NMEA[idx++] = buff.gpsraw;   //buffer   
    } while(buff.gpsraw != 13 && buff.gpsraw != 10);
    buff.NMEA[idx] = 0;      //null terminate

    //compare the string to get the RMC sentance

    if(strncmp(buff.NMEA, "$GPRMC", 6) == 0)
               parce_rmc();
   
     if(strncmp(buff.NMEA, "$GPGGA", 6) == 0)
              parce_gga();
      // print("GGA = %s\n", buff.NMEA);  
    
}

                    
void parce_rmc()

         /* this listing parses out the full sentance*/

   {
     
               //GPS SENTANCE NAME: it will be the first token
           strcpy(gps.gpsname,strtok(buff.NMEA, ","));
            
              //PARSE GPS TIME;  SECOND TOKEN AND CONVERT TO INT
           gps.gpstime = atoi(strcpy(buff.tempf,strtok(NULL, ",")));
           
              //PARSE OUT THE ZULU TIME (GMT)      
           zulu.hrs= (gps.gpstime/10000);
           zulu.min= (gps.gpstime - (zulu.hrs * 10000 ))/100;
           zulu.sec= (gps.gpstime - (zulu.hrs * 10000) - (zulu.min * 100));
           
             //PARSE SATELLITE FIX: it will be the third token
            // "A" active "V" void       
           strncpy( gps.fix,strtok(NULL, ","),1); 
            
            
            
                       /*LATITUDE*/         
             
              //COPY LATITUDE TOKEN 4
             // example "4807.038"
           strcpy(buff.tempf,strtok(NULL, ","));
             
              //convert string to float
           gps.lat=strtof(buff.tempf,NULL); 
           
              //obtain degrees by deviding the float by 100
           latdeg= (gps.lat/100);
           
              // obtain minutes and seconds 
           latmintemp= (gps.lat - latdeg*100);
           
               //use this function modf();
              //double modf (double x, double* intpart);
             //break into fractional and integral parts
           tvar.fractparta = modf (latmintemp , &latmin);
               /*multiply the fractional part by 60 to get the
                ss.s seconds */ 
               
           latsec= (tvar.fractparta * 60);
           
           int_latmin= latmin;
           
              //PARSE OUT TOKEN 6 THE "N" "S" CHARACTER
           strcpy( gps.latchar,strtok(NULL, ",")); 
             
             
                     /*LONGITUDE*/
            
            
              //PARSE OUT TOKEN 7 LONGITUDE ex:11823.377930 
           strcpy(buff.tempf,strtok(NULL, ","));
           
              //CONVERT STRING TO FLOAT
           gps.longitude=strtof(buff.tempf,NULL); 
           
              //DEVIDE STRING BY 100 EXTRACT DEGREES
           longdeg= (gps.longitude/100);
           
              //EXTRACT MINUTES AND SECONDS
           longmintemp= ((gps.longitude - longdeg*100));
           //param = longmintemp;
           
            //use this function modf();
              //double modf (double x, double* intpart);
             //break into fractional and integral pa
           tvar.fractpart = modf (longmintemp , &longmin);
          // longmin=intpart; 
           longsec= tvar.fractpart * 60;
           
           int_longmin= longmin;
         strcpy( gps.longchar,strtok(NULL, ",")); 
        
                    /*VELOCITY*/
   
          //EXTRACT VELOCITY TOKEN 8
           strcpy(buff.tempf,strtok(NULL, ","));
           
          //CONVERT TO FLOATING POINT
           gps.speed=strtof(buff.tempf,NULL); 
       
          
                     /*DATE*/
     
          //EXTRACT DAT AND CONVERT TO INT
           gps.date = atoi(  strcpy(buff.tempf,strtok(NULL, ","))); 
           
          //PARSE DAY MONTH YEAR    
           kenda.day= (gps.date/10000);
           kenda.month= (gps.date - (kenda.day * 10000 ))/100;
           kenda.year= (gps.date - (kenda.day * 10000) - (kenda.month * 100));
            
                 /*MAGNETIC VARIATION*/ 
  
          //EXTRACT MAGNETIC VARIATION
      gps.magvar = atof(strcpy(buff.tempf,strtok(NULL, ",")));  
     // strcpy(buff.tempf,strtok(NULL, ","));
       //    gps.magvar=strtol(  tempf,NULL,4); 
     
         print_data();   
   }   
   

                    
void parce_gga()

         /* this listing parses out the full sentance*/

   {
     
               //GPS SENTANCE NAME: it will be the first token
           strcpy(gps.gpsname,strtok(buff.NMEA, ","));
            
              //PARSE GPS TIME;  SECOND TOKEN AND CONVERT TO INT
           gps.gpstime = atoi(strcpy(buff.tempf,strtok(NULL, ",")));
           
              //PARSE OUT THE ZULU TIME (GMT)      
           zulu.hrs= (gps.gpstime/10000);
           zulu.min= (gps.gpstime - (zulu.hrs * 10000 ))/100;
           zulu.sec= (gps.gpstime - (zulu.hrs * 10000) - (zulu.min * 100));
           
             //PARSE SATELLITE FIX: it will be the third token
            // "A" active "V" void       
         //  strncpy( gps.fix,strtok(NULL, ","),1); 
            
            
            
                       /*LATITUDE*/         
             
              //COPY LATITUDE TOKEN 4
             // example "4807.038"
           strcpy(buff.tempf,strtok(NULL, ","));
             
              //convert string to float
           gps.lat=strtof(buff.tempf,NULL); 
           
              //obtain degrees by deviding the float by 100
           latdeg= (gps.lat/100);
           
              // obtain minutes and seconds 
           latmintemp= (gps.lat - latdeg*100);
           
               //use this function modf();
              //double modf (double x, double* intpart);
             //break into fractional and integral parts
           tvar.fractparta = modf (latmintemp , &latmin);
               /*multiply the fractional part by 60 to get the
                ss.s seconds */ 
               
           latsec= (tvar.fractparta * 60);
           
           int_latmin= latmin;
           
              //PARSE OUT TOKEN 6 THE "N" "S" CHARACTER
           strcpy( gps.latchar,strtok(NULL, ",")); 
             
             
                     /*LONGITUDE*/
            
            
              //PARSE OUT TOKEN 7 LONGITUDE ex:11823.377930 
           strcpy(buff.tempf,strtok(NULL, ","));
           
              //CONVERT STRING TO FLOAT
           gps.longitude=strtof(buff.tempf,NULL); 
           
              //DEVIDE STRING BY 100 EXTRACT DEGREES
           longdeg= (gps.longitude/100);
           
              //EXTRACT MINUTES AND SECONDS
           longmintemp= ((gps.longitude - longdeg*100));
           //param = longmintemp;
           
            //use this function modf();
              //double modf (double x, double* intpart);
             //break into fractional and integral pa
           tvar.fractpart = modf (longmintemp , &longmin);
          // longmin=intpart; 
           longsec= tvar.fractpart * 60;
           
           int_longmin= longmin;
         strcpy( gps.longchar,strtok(NULL, ",")); 
        
                    /*VELOCITY*/
   
   
   //PARSE SATELLITE FIX: it will be the third token
            // "A" active "V" void       
           strncpy( gps.fix,strtok(NULL, ","),1); 
          //EXTRACT VELOCITY TOKEN 8
          
          
           //PARSE SATELLITE FIX: it will be the third token
            // "A" active "V" void       
          // strncpy( gps.sats,strtok(NULL, ","),1); 
       gps.sats = atoi(strcpy(buff.tempf,strtok(NULL, ",")));
       
        // "A" active "V" void       
         //  strncpy( gps.dilution,strtok(NULL, ","),1); 
           gps.dilution = atof(strcpy(buff.tempf,strtok(NULL, ",")));
           // "A" active "V" void       
          // strncpy( gps.alt,strtok(NULL, ","),1); 
           
           buff.floatemp = atof(strcpy(buff.tempf,strtok(NULL, ",")));
           gps.alt = (buff.floatemp * 3.2808);
           strcpy( gps.altchar,strtok(NULL, ","));
                     /*DATE*/
    // strncpy( gps.geoid,strtok(NULL, ","),1);
  buff.floatemp    = atof(strcpy(buff.tempf,strtok(NULL, ",")));
      gps.geoid= (buff.floatemp * 3.2808);   
         print_data();   
   }   
   
 

void print_data()


    {
     
       print("GPS SENTANCE:   %15s\n\n", gps.gpsname); //works
      
      //  print("zulu time:  %d\n\n", gps.gpstime); //works
      
       /* print("hrs %d\n\n",zulu.hrs);
      
          print("min %d\n\n",zulu.min);
    
          print("sec %d\n\n",zulu.sec);*/

              //%2d moves output two spaces
       print("Date:%2d: %d: %d       UTC TIME: %2d: %d: %d\n\n",kenda.month,kenda.day,kenda.year
       ,zulu.hrs,zulu.min,zulu.sec); //works 
       
        // print("Date:  %d\n\n", kenda.day); //works 
       //  print("Date:  %d\n\n", kenda.month); //works 
      //  print("Date:  %d\n\n", kenda.year); //works 
     //  print("UTC TIME %d:%d:%d\n\n",zulu.hrs,zulu.min,zulu.sec);
      
      
      print("SATELLITE FIX:  %s\n\n", gps.fix); //works 
      
      
      print("RAW LATTITUDE: %f %s\n\n", gps.lat,gps.latchar); //works
        //  print("lat %d\n",latdeg);
        //  print("latmintemp %f\n",latmintemp);
        //  print("latmintemp %f\n",parama);
        //  print("latmin %f\n",latmin);
        //  print("intpart %f\n",intparta);
        //  print("fractpart %f\n",fractparta);
        //  print("latsec %f\n",latsec);
        
      print("LATTITUDE: DEG %d MIN %d  SEC %f %s\n\n", latdeg,int_latmin,latsec,gps.latchar); //works
     
       
       
      print(" RAW LONGITUDE:  %f  %s\n\n", gps.longitude, gps.longchar); //works
      
        //  print("longmintemp %f\n",longmintemp);
        //  print("longmintemp %f\n",param);
   
        //  print("intpart %f\n",intpart);
        //  print("longmin %f\n",longmin);
        //  print("fractpart %f\n",fractpart);
    
       print("LONGITUDE: DEG %d MIN %d SEC %f %s\n\n",longdeg,int_longmin,longsec,gps.longchar); //works
  
       print("VELOCITY:  %f\n\n", gps.sats); //works 
  
      
       print("MAGNETIC VARIATION:  %f\n\n", gps.magvar); //works 
   
   
       print("\n\n\n");
   
  // print(CLREOL);
  // print(HOME);
   pause(500);
    }    
    
    



                